package com.example.patientmonitoring;

import androidx.appcompat.app.AppCompatActivity;

import android.app.AlertDialog;
import android.content.Context;
import android.content.Intent;
import android.os.AsyncTask;
import android.os.Bundle;
import android.text.TextUtils;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLEncoder;

import io.paperdb.Paper;

public class AddPatientActivity extends AppCompatActivity {

    EditText name, address, gender, age;
    public String name1, address1, gender1, age1;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_add_patient);
        Paper.init(this);
        getSupportActionBar().setTitle("Add new patient");


        name = (EditText) findViewById(R.id.addpatient_name_input);
        gender =(EditText) findViewById(R.id.addpatient_gender_input);
        age = (EditText) findViewById(R.id.addpatient_age_input);
        address = (EditText) findViewById(R.id.addpatient_address_input);
        Button btn_create = (Button) findViewById(R.id.addpatient_btn);


    }

    public void onRegisterNewPatient(View view) {
        final String user_id = Paper.book().read("user_id");
        name1 = name.getText().toString();
        gender1 = gender.getText().toString();
        age1 = age.getText().toString();
        address1 = address.getText().toString();

        if (TextUtils.isEmpty(name1))
        {
            Toast.makeText(this, "Please insert patient name", Toast.LENGTH_SHORT).show();
        }
        else if (TextUtils.isEmpty(gender1))
        {
            Toast.makeText(this, "Please insert patient gender", Toast.LENGTH_SHORT).show();
        }
        else if (TextUtils.isEmpty(age1))
        {
            Toast.makeText(this, "Please insert patient age", Toast.LENGTH_SHORT).show();
        }
        else if (TextUtils.isEmpty(address1))
        {
            Toast.makeText(this, "Please insert patient address", Toast.LENGTH_SHORT).show();
        }
        else {
            AddNewPatient bg = new AddNewPatient(this);
            bg.execute(name1, gender1, age1, address1, user_id);
        }
    }

    public class AddNewPatient extends AsyncTask<String,Void,String> {
        Context context;
        String name, age, gender, address, user_id;
        AlertDialog alertDialog;

        AddNewPatient (Context ctx) {
            context = ctx;
        }
        @Override
        protected String doInBackground(String... params) {
            String login_url = "http://192.168.0.100/android/createPatient.php";
                try {
                    name = params[0];
                    gender = params[1];
                    age = params[2];
                    address = params[3];
                    user_id = params[4];
                    URL url = new URL(login_url);
                    HttpURLConnection httpURLConnection = (HttpURLConnection)url.openConnection();
                    httpURLConnection.setRequestMethod("POST");
                    httpURLConnection.setDoOutput(true);
                    httpURLConnection.setDoInput(true);
                    OutputStream outputStream = httpURLConnection.getOutputStream();
                    BufferedWriter bufferedWriter = new BufferedWriter(new OutputStreamWriter(outputStream, "UTF-8"));
                    String post_data = URLEncoder.encode("user","UTF-8")+"="+URLEncoder.encode(user_id,"UTF-8")+"&"
                            +URLEncoder.encode("name","UTF-8")+"="+URLEncoder.encode(name,"UTF-8")+"&"
                            +URLEncoder.encode("age","UTF-8")+"="+URLEncoder.encode(age,"UTF-8")+"&"
                            +URLEncoder.encode("address","UTF-8")+"="+URLEncoder.encode(address,"UTF-8")+"&"
                            +URLEncoder.encode("gender","UTF-8")+"="+URLEncoder.encode(gender,"UTF-8");
                    bufferedWriter.write(post_data);
                    bufferedWriter.flush();
                    bufferedWriter.close();
                    outputStream.close();
                    InputStream inputStream = httpURLConnection.getInputStream();
                    BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(inputStream,"iso-8859-1"));
                    String result="";
                    String line="";
                    while((line = bufferedReader.readLine())!= null) {
                        result += line;
                    }
                    bufferedReader.close();
                    inputStream.close();
                    httpURLConnection.disconnect();
                    return result;
                } catch (MalformedURLException e) {
                    e.printStackTrace();
                } catch (IOException e) {
                    e.printStackTrace();
                }

            return null;
        }

        @Override
        protected void onPreExecute() {
            alertDialog = new AlertDialog.Builder(context).create();
            alertDialog.setTitle("");
        }

        @Override
        protected void onPostExecute(String result) {
            Log.d("result", result);
            if(result.contains("Insert Successful")) {
                Toast toast=Toast. makeText(getApplicationContext(),"Registration Successful",Toast. LENGTH_SHORT);
                toast. show();
                Intent intent = new Intent(context.getApplicationContext(), PatientListActivity.class);
                context.startActivity(intent);
            }
            else {
                alertDialog.setMessage("Registration Unsuccessful. Please Try Again");
                alertDialog.show();
            }
        }

        @Override
        protected void onProgressUpdate(Void... values) {
            super.onProgressUpdate(values);
        }
    }
}
