package com.example.patientmonitoring;

import androidx.appcompat.app.AppCompatActivity;

import android.app.AlertDialog;
import android.content.Context;
import android.content.Intent;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.RadioGroup;
import android.widget.TextView;
import android.widget.Toast;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLEncoder;

public class KeyinActivity extends AppCompatActivity {

    RadioGroup systolic, heartrate, temperature, avpu, respitory, diastolic;
    TextView txtTotal;
    public Integer total_score = 0;
    public Integer val1=0, val2=0, val3=0, val4=0, val5=0, val6=0;
    public String systolicVal, respitoryVal, tempVal, heartRateVal, diastolicVal, avpuVal;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_keyin);
        String patient_id = "1";

        final String getCaretakerID = getIntent().getStringExtra("caretaker_id");
        final String getPatientID = getIntent().getStringExtra("patient_id");

        getSupportActionBar().setTitle("Key in Patient ID: " + getPatientID);

        diastolic = (RadioGroup) findViewById(R.id.rg_diastolic);
        systolic = (RadioGroup) findViewById(R.id.rg_systolic);
        heartrate = (RadioGroup) findViewById(R.id.rg_heartrate);
        temperature = (RadioGroup) findViewById(R.id.rg_temperature);
        avpu = (RadioGroup) findViewById(R.id.rg_avpu);
        respitory = (RadioGroup) findViewById(R.id.rg_respitory);
        txtTotal = (TextView) findViewById(R.id.textView14);

        Button btn_save = (Button) findViewById(R.id.btn_save);

        systolic.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(RadioGroup radioGroup, int i) {
                SystolicRadioGroup(i);
                calculateTotal();
                txtTotal.setText(total_score.toString());
            }
        });

        heartrate.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(RadioGroup radioGroup, int i) {
                HeartRateRadioGroup(i);
                calculateTotal();
                txtTotal.setText(total_score.toString());
            }
        });

        diastolic.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(RadioGroup radioGroup, int i) {
                DiastolicRadioGroup(i);
                calculateTotal();
                txtTotal.setText(total_score.toString());
            }
        });

        temperature.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(RadioGroup radioGroup, int i) {
                TempRadioGroup(i);
                calculateTotal();
                txtTotal.setText(total_score.toString());
            }
        });

        avpu.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(RadioGroup radioGroup, int i) {
                AVPURadioGroup(i);
                calculateTotal();
                txtTotal.setText(total_score.toString());
            }
        });

        respitory.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(RadioGroup radioGroup, int i) {
                RespitoryRadioGroup(i);
                calculateTotal();
                txtTotal.setText(total_score.toString());
            }
        });


        btn_save.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View view) {
                if(systolic.getCheckedRadioButtonId() == -1 || temperature.getCheckedRadioButtonId() == -1 || heartrate.getCheckedRadioButtonId() == -1 || avpu.getCheckedRadioButtonId() == -1 || respitory.getCheckedRadioButtonId() == -1 || diastolic.getCheckedRadioButtonId() == -1){
                    Toast toast=Toast. makeText(getApplicationContext(),"Please select every category", Toast. LENGTH_SHORT);
                    toast. show();
                }
                else{
                    ScoreUpdate score_update = new ScoreUpdate(KeyinActivity.this);
                    score_update.execute(getPatientID, total_score.toString());

                    CreateScore create_update = new CreateScore(KeyinActivity.this);
                    create_update.execute(getPatientID, total_score.toString(), systolicVal, respitoryVal, tempVal, heartRateVal, avpuVal, diastolicVal);
                }
            }
        });
    }

    public class CreateScore extends AsyncTask<String,Void,String> {
        Context context;
        String val1, val2, val3, val4, val5, val6, total, id;
        AlertDialog alertDialog;

        CreateScore (Context ctx) {
            context = ctx;
        }
        @Override
        protected String doInBackground(String... params) {
            String login_url = "http://192.168.0.100/android/createResult.php";
            try {
                id = params[0];
                val1 = params[2];
                val2 = params[3];
                val3 = params[4];
                val4 = params[5];
                val5 = params[6];
                val6 = params[7];
                total = params[1];
                URL url = new URL(login_url);
                HttpURLConnection httpURLConnection = (HttpURLConnection)url.openConnection();
                httpURLConnection.setRequestMethod("POST");
                httpURLConnection.setDoOutput(true);
                httpURLConnection.setDoInput(true);
                OutputStream outputStream = httpURLConnection.getOutputStream();
                BufferedWriter bufferedWriter = new BufferedWriter(new OutputStreamWriter(outputStream, "UTF-8"));
                String post_data = URLEncoder.encode("user","UTF-8")+"="+URLEncoder.encode(id,"UTF-8")+"&"
                        +URLEncoder.encode("total","UTF-8")+"="+URLEncoder.encode(total,"UTF-8")+"&"
                        +URLEncoder.encode("val1","UTF-8")+"="+URLEncoder.encode(val1,"UTF-8")+"&"
                        +URLEncoder.encode("val2","UTF-8")+"="+URLEncoder.encode(val2,"UTF-8")+"&"
                        +URLEncoder.encode("val3","UTF-8")+"="+URLEncoder.encode(val3,"UTF-8")+"&"
                        +URLEncoder.encode("val4","UTF-8")+"="+URLEncoder.encode(val4,"UTF-8")+"&"
                        +URLEncoder.encode("val5","UTF-8")+"="+URLEncoder.encode(val5,"UTF-8")+"&"
                        +URLEncoder.encode("val6","UTF-8")+"="+URLEncoder.encode(val6,"UTF-8");
                bufferedWriter.write(post_data);
                bufferedWriter.flush();
                bufferedWriter.close();
                outputStream.close();
                InputStream inputStream = httpURLConnection.getInputStream();
                BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(inputStream,"iso-8859-1"));
                String result="";
                String line="";
                while((line = bufferedReader.readLine())!= null) {
                    result += line;
                }
                bufferedReader.close();
                inputStream.close();
                httpURLConnection.disconnect();
                return result;
            } catch (MalformedURLException e) {
                e.printStackTrace();
            } catch (IOException e) {
                e.printStackTrace();
            }

            return null;
        }

        @Override
        protected void onPreExecute() {
            alertDialog = new AlertDialog.Builder(context).create();
            alertDialog.setTitle("");
        }

        @Override
        protected void onPostExecute(String result) {
            Log.d("result", result);
            if(result.contains("Insert Successful")) {
                Toast toast=Toast. makeText(getApplicationContext(),"Key in Successful",Toast. LENGTH_SHORT);
                toast. show();
                Intent intent = new Intent(context.getApplicationContext(), PatientListActivity.class);
                context.startActivity(intent);
            }
            else {
                alertDialog.setMessage("Registration Unsuccessful. Please Try Again");
                alertDialog.show();
            }
        }

        @Override
        protected void onProgressUpdate(Void... values) {
            super.onProgressUpdate(values);
        }
    }

    class ScoreUpdate extends AsyncTask<String,Void,String> {
        Context context;
        String patient_id, score;
        AlertDialog alertDialog;
        ScoreUpdate (Context ctx) {
            context = ctx;
        }
        @Override
        protected String doInBackground(String... params) {
            String login_url = "http://192.168.0.100/android/updateScore.php";
            try {
                patient_id = params[0];
                score = params[1];
                URL url = new URL(login_url);
                HttpURLConnection httpURLConnection = (HttpURLConnection)url.openConnection();
                httpURLConnection.setRequestMethod("POST");
                httpURLConnection.setDoOutput(true);
                httpURLConnection.setDoInput(true);
                OutputStream outputStream = httpURLConnection.getOutputStream();
                BufferedWriter bufferedWriter = new BufferedWriter(new OutputStreamWriter(outputStream, "UTF-8"));
                String post_data = URLEncoder.encode("patient_id","UTF-8")+"="+URLEncoder.encode(patient_id,"UTF-8")+"&"
                        +URLEncoder.encode("score","UTF-8")+"="+URLEncoder.encode(score,"UTF-8");
                Log.d("url", post_data);
                bufferedWriter.write(post_data);
                bufferedWriter.flush();
                bufferedWriter.close();
                outputStream.close();
                InputStream inputStream = httpURLConnection.getInputStream();
                BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(inputStream,"iso-8859-1"));
                String result="";
                String line="";
                while((line = bufferedReader.readLine())!= null) {
                    result += line;
                }
                bufferedReader.close();
                inputStream.close();
                httpURLConnection.disconnect();
                return result;
            } catch (MalformedURLException e) {
                e.printStackTrace();
            } catch (IOException e) {
                e.printStackTrace();
            }

            return null;
        }
        @Override
        protected void onPreExecute() {
            alertDialog = new AlertDialog.Builder(context).create();
            alertDialog.setTitle("");
        }

        @Override
        protected void onPostExecute(String result) {
            Log.d("result", result);
            if(result.contains("Insert Successful")) {
                Toast toast=Toast. makeText(getApplicationContext(),"Key in Successful",Toast. LENGTH_SHORT);
                toast. show();
                Intent intent = new Intent(context.getApplicationContext(), PatientListActivity.class);
                context.startActivity(intent);
            }
            else {
                alertDialog.setMessage("Registration Unsuccessful. Please Try Again");
                alertDialog.show();
            }
        }

        @Override
        protected void onProgressUpdate(Void... values) {
            super.onProgressUpdate(values);
        }
    }

    private void SystolicRadioGroup(int id){
        switch (id){
            case R.id.BP1:
                val1= 3;
                systolicVal = "70";
                break;
            case R.id.BP2:
                val1= 2;
                systolicVal = "71";
                break;
            case R.id.BP3:
                val1= 1;
                systolicVal = "81";
                break;
            case R.id.BP4:
                val1= 0;
                systolicVal = "101";
                break;
            case R.id.BP5:
                val1= 2;
                systolicVal = "200";
                break;
        }
    }

    private void HeartRateRadioGroup(int id){
        switch (id){
            case R.id.HR1:
                val2= 2;
                heartRateVal = "40";
                break;
            case R.id.HR2:
                val2= 1;
                heartRateVal = "41";
                break;
            case R.id.HR3:
                val2= 0;
                heartRateVal = "51";
                break;
            case R.id.HR4:
                val2= 1;
                heartRateVal = "101";
                break;
            case R.id.HR5:
                val2= 2;
                heartRateVal = "111";
                break;
            case R.id.HR6:
                val2= 3;
                heartRateVal = "130";
                break;
        }
    }

    private void TempRadioGroup(int id){
        switch (id){
            case R.id.T1:
                val3= 2;
                tempVal = "35";
                break;
            case R.id.T2:
                val3= 0;
                tempVal = "36";
                break;
            case R.id.T3:
                val3= 2;
                tempVal = "38";
                break;
        }
    }

    private void RespitoryRadioGroup(int id){
        switch (id){
            case R.id.RR1:
                val4= 2;
                respitoryVal = "9";
                break;
            case R.id.RR2:
                val4= 0;
                respitoryVal = "10";
                break;
            case R.id.RR3:
                val4= 1;
                respitoryVal = "15";
                break;
            case R.id.RR4:
                val4= 2;
                respitoryVal = "21";
                break;
            case R.id.RR5:
                val4= 3;
                respitoryVal = "30";
                break;
        }
    }

    private void AVPURadioGroup(int id){
        switch (id){
            case R.id.AVPU1:
                val5= 0;
                avpuVal = "Alert";
                break;
            case R.id.AVPU2:
                val5= 1;
                avpuVal = "Reacts to voice";
                break;
            case R.id.AVPU3:
                val5= 2;
                avpuVal = "Reacts to pain";
                break;
            case R.id.AVPU4:
                val5= 3;
                avpuVal = "Unresponsive";
                break;
        }
    }

    private void DiastolicRadioGroup(int id){
        switch (id){
            case R.id.D1:
                val6= 1;
                diastolicVal = "49";
                break;
            case R.id.D2:
                val6= 0;
                diastolicVal = "50";
                break;
            case R.id.D3:
                val6= 1;
                diastolicVal = "90";
                break;
            case R.id.D4:
                val6= 2;
                diastolicVal = "100";
                break;
            case R.id.D5:
                val6= 3;
                diastolicVal = "110";
                break;
        }
    }

    public void calculateTotal(){
        total_score = val1+val2+val3+val4+val5+val6;
    }

}
