package com.example.patientmonitoring;

import android.content.Context;
import android.content.Intent;
import android.graphics.Color;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.RatingBar;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.example.patientmonitoring.Prevalent.Patients;

import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.List;

public class PatientListRecycler extends RecyclerView.Adapter<PatientListRecycler.PatientViewHolder> {

    private Context mCtx;
    private List<Patients> patientList;

    public PatientListRecycler(Context mCtx, List<Patients> patientList) {
        this.mCtx = mCtx;
        this.patientList = patientList;
    }

    @Override
    public PatientViewHolder onCreateViewHolder(ViewGroup parent, int viewType) {
        LayoutInflater inflater = LayoutInflater.from(mCtx);
        View view = inflater.inflate(R.layout.patientlist_list, null);
        return new PatientViewHolder(view);
    }

    @Override
    public void onBindViewHolder(PatientViewHolder holder, int position) {
        final Patients patient = patientList.get(position);

        holder.mId.setText("ID: "+patient.getPatient_id());
        holder.mName.setText(patient.getName());
        if(patient.getLatest_score().equals("null")){
            holder.mScore.setText("");
        }
        else {
            holder.mScore.setText(patient.getLatest_score());
            if(Integer.parseInt(patient.getLatest_score())>10)
            holder.mScore.setTextColor(Color.RED);
            else if(Integer.parseInt(patient.getLatest_score())>6)
                holder.mScore.setTextColor(Color.parseColor("#000080"));
            else if(Integer.parseInt(patient.getLatest_score())>2)
                holder.mScore.setTextColor(Color.parseColor("#e1ad01"));
        }

        holder.itemView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Intent intent = new Intent(mCtx, ProfilePatientActivity.class);
                intent.putExtra("name", patient.getName());
                intent.putExtra("patient_id", patient.getPatient_id());
                intent.putExtra("address", patient.getAddress());
                intent.putExtra("age", patient.getAge());
                intent.putExtra("score", patient.getLatest_score());
                intent.putExtra("gender", patient.getGender());

                mCtx.startActivity(intent);
            }
        });
    }

    @Override
    public int getItemCount() {
        return patientList.size();
    }

    class PatientViewHolder extends RecyclerView.ViewHolder {

        private TextView mName, mId, mScore;

        public PatientViewHolder(View itemView) {
            super(itemView);

            mName = itemView.findViewById(R.id.textViewShortDesc);
            mId = itemView.findViewById(R.id.textViewTitle);
            mScore = itemView.findViewById(R.id.textViewPrice);


        }
    }
}
