package com.example.patientmonitoring;

import androidx.appcompat.app.AppCompatActivity;

import android.app.AlertDialog;
import android.content.Context;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;

import com.android.volley.Request;
import com.android.volley.Response;
import com.android.volley.VolleyError;
import com.android.volley.toolbox.StringRequest;
import com.android.volley.toolbox.Volley;
import com.example.patientmonitoring.Prevalent.Caretaker;
import com.example.patientmonitoring.Prevalent.Patients;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.List;

import io.paperdb.Paper;

public class ProfileCaretakerActivity extends AppCompatActivity {

    EditText name, password, email, organisation;
    private List<Caretaker> caretaker;
    final String user_id = Paper.book().read("user_id");

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_profile_caretaker);
        getSupportActionBar().setTitle("Profile: "+ user_id);

        name = findViewById(R.id.edit_fullname_ct);
        password = (EditText) findViewById(R.id.editct_password);
        email = (EditText) findViewById(R.id.editct_email);
        organisation = (EditText) findViewById(R.id.editct_organisation);
        Button btn_update = (Button) findViewById(R.id.editct_btn);

        loadCaretaker();

        btn_update.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                ProfileCaretakerActivity.CaretakerUpdate patient_update = new ProfileCaretakerActivity.CaretakerUpdate(ProfileCaretakerActivity.this);
                patient_update.execute(name.getText().toString(), password.getText().toString(), email.getText().toString(), organisation.getText().toString(), user_id);
            }
        });

    }

    private void loadCaretaker() {
        String newURL = "http://192.168.0.100/android/getCaretaker.php"+"?caretaker_id="+user_id;
        StringRequest stringRequest = new StringRequest(Request.Method.GET, newURL,
                new Response.Listener<String>() {
                    @Override
                    public void onResponse(String response) {
                        Log.d("check", response);
                        try {
                            //converting the string to json array object
                            JSONArray array = new JSONArray(response);
                            //traversing through all the object
                            for (int i = 0; i < array.length(); i++) {

                                //getting product object from json array
                                JSONObject patient = array.getJSONObject(i);

                                name.setText(patient.getString("caretaker_name"));
                                organisation.setText(patient.getString("organisation"));
                                email.setText(patient.getString("email"));
                                password.setText(patient.getString("password"));
                            }
                        } catch (JSONException e) {
                            e.printStackTrace();
                        }
                    }
                },
                new Response.ErrorListener() {
                    @Override
                    public void onErrorResponse(VolleyError error) {

                    }
                });

        //adding our stringrequest to queue
        Volley.newRequestQueue(this).add(stringRequest);

    }

    class CaretakerUpdate extends AsyncTask<String,Void,String> {
        Context context;
        String name, password, email, organisation, caretaker_id;
        AlertDialog alertDialog;
        CaretakerUpdate (Context ctx) {
            context = ctx;
        }
        @Override
        protected String doInBackground(String... params) {
            String login_url = "http://192.168.0.100/android/updateCaretaker.php";
            try {
                name = params[0];
                password = params[1];
                email = params[2];
                organisation = params[3];
                caretaker_id = params[4];
                URL url = new URL(login_url);
                HttpURLConnection httpURLConnection = (HttpURLConnection)url.openConnection();
                httpURLConnection.setRequestMethod("POST");
                httpURLConnection.setDoOutput(true);
                httpURLConnection.setDoInput(true);
                OutputStream outputStream = httpURLConnection.getOutputStream();
                BufferedWriter bufferedWriter = new BufferedWriter(new OutputStreamWriter(outputStream, "UTF-8"));
                String post_data = URLEncoder.encode("caretaker_id","UTF-8")+"="+URLEncoder.encode(caretaker_id,"UTF-8")+"&"
                        +URLEncoder.encode("name","UTF-8")+"="+URLEncoder.encode(name,"UTF-8")+"&"
                        +URLEncoder.encode("password","UTF-8")+"="+URLEncoder.encode(password,"UTF-8")+"&"
                        +URLEncoder.encode("email","UTF-8")+"="+URLEncoder.encode(email,"UTF-8")+"&"
                        +URLEncoder.encode("organisation","UTF-8")+"="+URLEncoder.encode(organisation,"UTF-8");
                Log.d("url", post_data);
                bufferedWriter.write(post_data);
                bufferedWriter.flush();
                bufferedWriter.close();
                outputStream.close();
                InputStream inputStream = httpURLConnection.getInputStream();
                BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(inputStream,"iso-8859-1"));
                String result="";
                String line="";
                while((line = bufferedReader.readLine())!= null) {
                    result += line;
                }
                bufferedReader.close();
                inputStream.close();
                httpURLConnection.disconnect();
                return result;
            } catch (MalformedURLException e) {
                e.printStackTrace();
            } catch (IOException e) {
                e.printStackTrace();
            }

            return null;
        }

        @Override
        protected void onPreExecute() {
            alertDialog = new AlertDialog.Builder(context).create();
            alertDialog.setTitle("");
        }

        @Override
        protected void onPostExecute(String result) {
            if(result.contains("Record Updated Successfully")) {
                alertDialog.setMessage("Data Updated Successfully");
                alertDialog.show();
            }
            else {
                alertDialog.setMessage("Something went wrong");
                alertDialog.show();
            }
        }

        @Override
        protected void onProgressUpdate(Void... values) {
            super.onProgressUpdate(values);
        }
    }
}
