package com.example.patientmonitoring;

import androidx.appcompat.app.AppCompatActivity;

import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.media.Image;
import android.os.AsyncTask;
import android.os.Bundle;
import android.provider.ContactsContract;
import android.text.Editable;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

import com.android.volley.Request;
import com.android.volley.Response;
import com.android.volley.VolleyError;
import com.android.volley.toolbox.StringRequest;
import com.android.volley.toolbox.Volley;
import com.example.patientmonitoring.Prevalent.Patients;

import org.apache.http.NameValuePair;
import org.apache.http.message.BasicNameValuePair;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import io.paperdb.Paper;

import static android.os.Build.ID;

public class ProfilePatientActivity extends AppCompatActivity {

    EditText name, age, gender, address;
    ImageView img_keyin, img_patientlist, img_history;
    final String user_id = Paper.book().read("user_id");

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        Paper.init(this);
        setContentView(R.layout.activity_profile_patient);

        name = findViewById(R.id.editp_fullname);
        age = (EditText) findViewById(R.id.editp_age);
        gender = (EditText) findViewById(R.id.editp_gender);
        address = (EditText) findViewById(R.id.editp_address);
        Button  btn_update = (Button) findViewById(R.id.editp_update_btn);
        img_keyin = (ImageView) findViewById(R.id.keyin_btn);
        img_history = (ImageView) findViewById(R.id.history_btn);
        img_patientlist = (ImageView) findViewById(R.id.patients_btn);

        final String getName = getIntent().getStringExtra("name");
        final String getPatientID = getIntent().getStringExtra("patient_id");
        final String getAddress = getIntent().getStringExtra("address");
        final String getGender = getIntent().getStringExtra("gender");
        final String getAge = getIntent().getStringExtra("age");
        final String getScore = getIntent().getStringExtra("score");

        getSupportActionBar().setTitle("Patient ID: "+ getPatientID);

        name.setText(getName);
        age.setText(getAge);
        address.setText(getAddress);
        gender.setText(getGender);

        img_keyin.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Intent intent = new Intent(ProfilePatientActivity.this, KeyinActivity.class);
                intent.putExtra("caretaker_id", user_id);
                intent.putExtra("patient_id", getPatientID);
                startActivity(intent);
            }
        });

        img_history.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Intent intent = new Intent(ProfilePatientActivity.this, HistoryActivity.class);
                intent.putExtra("caretaker_id", user_id);
                intent.putExtra("patient_id", getPatientID);
                startActivity(intent);
            }
        });

        img_patientlist.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Intent intent = new Intent(ProfilePatientActivity.this, PatientListActivity.class);
                startActivity(intent);
            }
        });

        btn_update.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                PatientUpdate patient_update = new PatientUpdate(ProfilePatientActivity.this);
                patient_update.execute(getPatientID, name.getText().toString(), age.getText().toString(), gender.getText().toString(), address.getText().toString());
            }
        });

    }

    class PatientUpdate extends AsyncTask<String,Void,String> {
        Context context;
        String patient_id, name, age, gender, address;
        AlertDialog alertDialog;
        PatientUpdate (Context ctx) {
            context = ctx;
        }
        @Override
        protected String doInBackground(String... params) {
            String login_url = "http://192.168.0.100/android/updatePatient.php";
                try {
                    patient_id = params[0];
                    name = params[1];
                    age = params[2];
                    gender = params[3];
                    address = params[4];
                    URL url = new URL(login_url);
                    HttpURLConnection httpURLConnection = (HttpURLConnection)url.openConnection();
                    httpURLConnection.setRequestMethod("POST");
                    httpURLConnection.setDoOutput(true);
                    httpURLConnection.setDoInput(true);
                    OutputStream outputStream = httpURLConnection.getOutputStream();
                    BufferedWriter bufferedWriter = new BufferedWriter(new OutputStreamWriter(outputStream, "UTF-8"));
                    String post_data = URLEncoder.encode("patient_id","UTF-8")+"="+URLEncoder.encode(patient_id,"UTF-8")+"&"
                            +URLEncoder.encode("name","UTF-8")+"="+URLEncoder.encode(name,"UTF-8")+"&"
                            +URLEncoder.encode("age","UTF-8")+"="+URLEncoder.encode(age,"UTF-8")+"&"
                            +URLEncoder.encode("gender","UTF-8")+"="+URLEncoder.encode(gender,"UTF-8")+"&"
                            +URLEncoder.encode("address","UTF-8")+"="+URLEncoder.encode(address,"UTF-8");
                    Log.d("url", post_data);
                    bufferedWriter.write(post_data);
                    bufferedWriter.flush();
                    bufferedWriter.close();
                    outputStream.close();
                    InputStream inputStream = httpURLConnection.getInputStream();
                    BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(inputStream,"iso-8859-1"));
                    String result="";
                    String line="";
                    while((line = bufferedReader.readLine())!= null) {
                        result += line;
                    }
                    bufferedReader.close();
                    inputStream.close();
                    httpURLConnection.disconnect();
                    return result;
                } catch (MalformedURLException e) {
                    e.printStackTrace();
                } catch (IOException e) {
                    e.printStackTrace();
                }

            return null;
        }

        @Override
        protected void onPreExecute() {
            alertDialog = new AlertDialog.Builder(context).create();
            alertDialog.setTitle("");
        }

        @Override
        protected void onPostExecute(String result) {
            Log.d("url", result);
            if(result.contains("Record Updated Successfully")) {
                alertDialog.setMessage("Data Updated Successfully");
                alertDialog.show();
            }
            else {
                alertDialog.setMessage("Something went wrong");
                alertDialog.show();
            }
        }

        @Override
        protected void onProgressUpdate(Void... values) {
            super.onProgressUpdate(values);
        }
    }
}
