package com.example.patientmonitoring;

import android.content.Context;
import android.content.Intent;
import android.graphics.Color;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.RatingBar;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.example.patientmonitoring.Prevalent.Patients;
import com.example.patientmonitoring.Prevalent.Result;

import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.List;

public class ResultAdapter extends RecyclerView.Adapter<ResultAdapter.ResultViewHolder> {

    private Context mCtx;
    private List<Result> resultList;

    public ResultAdapter(Context mCtx, List<Result> resultList) {
        this.mCtx = mCtx;
        this.resultList = resultList;
    }

    @Override
    public ResultViewHolder onCreateViewHolder(ViewGroup parent, int viewType) {
        LayoutInflater inflater = LayoutInflater.from(mCtx);
        View view = inflater.inflate(R.layout.result_list, null);
        return new ResultViewHolder(view);
    }

    @Override
    public void onBindViewHolder(ResultViewHolder holder, int position) {
        final Result result = resultList.get(position);

        holder.score.setText(result.getAVPU());
        holder.date.setText(result.getDate().substring(11,19));
    }

    @Override
    public int getItemCount() {
        return resultList.size();
    }

    class ResultViewHolder extends RecyclerView.ViewHolder {

        private TextView score, date;

        public ResultViewHolder(View itemView) {
            super(itemView);

            score = itemView.findViewById(R.id.txtview_score);
            date = itemView.findViewById(R.id.txtview_date);


        }
    }
}